


import java.applet.*;
import java.awt.*;
import java.awt.image.*;


/* "asterisk extends water" means that there are a lot
	of routines in water.java that this applet imports
	and uses, so if you want to understand this code,
	read and understand water.java first.

	The routines in this file replace those in water.java
	that have the same names. This is called "class inheritance".
	This allows a small amount of code to slightly modify
	existing programs that can be very large.

	Anyway. This is my bit for Java toy-making. I am Neal McDonald,
	this is my code, take and eat, but leave in a pointer to me:
	www.workly.com
	*/



public class asterisk extends water  {


	void initPart(int which) {
		int cx, cy;
		double gx, gy;

		gx = (Math.random() * imageX) * imageXscale + (double)imageXoffset;
		gy = (Math.random() * imageY) * imageYscale + (double)imageYoffset;

		parts[which][DIR] = Math.random() *360.0;
		parts[which][UPD] = Math.random() *10.0;
		parts[which][SPEED] = Math.random() * 10.0;

		partColors[which] = getColorC((int)gx, (int)gy);
		parts[which][XPOS] = Math.floor(gx/30.0)*40.0;
		parts[which][YPOS] = Math.floor(gy/50.0)*60.0;
		parts[which][OX] = parts[which][XPOS];
		parts[which][OY] = parts[which][YPOS];
	}

	void drawPart(Graphics gr, int which) {
		int px,py,ox,oy;

		px = ((int)parts[which][XPOS]);
		py = ((int)parts[which][YPOS]);
		ox = ((int)parts[which][OX]);
		oy = ((int)parts[which][OY]);

		if (parts[which][UPD] <0.0) {
			initPart(which);
		} else {
			parts[which][UPD] -= 1.0;
			r_setColor(gr, partColors[which]);
			r_drawLine(gr, px,py,ox,oy);
		}
	}

	void movePart(int which) {
		double dx, dy;
		int ix, jumped;

		ix = (int)(parts[which][DIR]) % 360;
		if (ix<0) ix+=360;
		parts[which][OX] = parts[which][XPOS];
		parts[which][OY] = parts[which][YPOS];
		parts[which][XPOS] += parts[which][SPEED] * cosines[ix];
		parts[which][YPOS] += parts[which][SPEED] * sines[ix];

		parts[which][DIR] += Math.random() * 20.0-10.0;

	}
}

